2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see https://www.gnu.org/licenses/ .
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19 echo "Error: The notmuch test suite requires a bash version >= 4.0"
20 echo "due to use of associative arrays within the test suite."
21 echo "Please try again with a newer bash (or help us fix the"
22 echo "test suite to be more portable). Thanks."
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34 echo >&2 'You do not seem to have built notmuch yet.'
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
46 # do not redirect again
48 *' --tee '*|*' --va'*)
50 BASE=test-results/$this_test
51 (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52 echo $? > $BASE.exit) | tee $BASE.out
53 test "$(cat $BASE.exit)" = 0
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
61 # Save STDOUT to fd 6 and STDERR to fd 7.
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
67 . "$NOTMUCH_SRCDIR/test/test-vars.sh" || exit 1
70 [ -e "${GNUPGHOME}/gpg.conf" ] && return
71 _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
72 at_exit_function _gnupg_exit
73 mkdir -p -m 0700 "$GNUPGHOME"
74 gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
75 test_debug "cat $GNUPGHOME/import.log"
76 if (gpg --quick-random --version >/dev/null 2>&1) ; then
77 echo quick-random >> "$GNUPGHOME"/gpg.conf
78 elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
79 echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
81 echo no-emit-version >> "$GNUPGHOME"/gpg.conf
83 # Change this if we ship a new test key
84 FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
85 SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
86 SELF_EMAIL="test_suite@notmuchmail.org"
87 printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
91 test_require_external_prereq openssl
94 [ -e "$GNUPGHOME/gpgsm.conf" ] && return
95 _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
96 at_exit_function _gnupg_exit
97 mkdir -p -m 0700 "$GNUPGHOME"
98 gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
99 --disable-dirmngr --import >"$GNUPGHOME"/import.log 2>&1 3<<<'' <$NOTMUCH_SRCDIR/test/smime/0xE0972A47.p12
100 fpr=$(gpgsm --batch --with-colons --list-key test_suite@notmuchmail.org | awk -F: '/^fpr/ {print $10}')
101 echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
102 gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
103 echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
104 printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
105 gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
106 --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
107 test_debug "cat $GNUPGHOME/import.log"
110 # Each test should start with something like this, after copyright notices:
112 # test_description='Description of this test...
113 # This test checks if command xyzzy does the right thing...
115 # . ./test-lib.sh || exit 1
119 while test "$#" -ne 0
125 immediate=t; shift ;;
133 with_dashes=t; shift ;;
140 valgrind=t; verbose=t; shift ;;
142 shift ;; # was handled already
144 echo "error: unknown test option '$1'" >&2; exit 1 ;;
148 if test -n "$debug"; then
150 printf -v $1 " %-4s" "[$((test_count - 1))]"
158 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
160 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] &&
161 tput -T "$ORIGINAL_TERM" -S <<<$'bold\nsetaf\nsgr0\n' >/dev/null 2>&1
170 # _tput run in subshell (``) only
171 _tput () { exec tput -T "$ORIGINAL_TERM" "$@"; }
172 unset BOLD RED GREEN BROWN SGR0
175 error) b=${BOLD=`_tput bold`}
176 c=${RED=`_tput setaf 1`} ;; # bold red
177 skip) b=${BOLD=`_tput bold`}
178 c=${GREEN=`_tput setaf 2`} ;; # bold green
179 pass) b= c=${GREEN=`_tput setaf 2`} ;; # green
180 info) b= c=${BROWN=`_tput setaf 3`} ;; # brown
181 *) b= c=; test -n "$quiet" && return ;;
185 sgr0=${SGR0=`_tput sgr0`}
187 printf " ${b}${c}${f}${sgr0}${st}" "$@"
191 test -z "$1" && test -n "$quiet" && return
195 printf " ${f}${st}" "$@"
200 say_color error "error: $*\n"
209 test "${test_description}" != "" ||
210 error "Test script did not set test_description."
212 if test "$help" = "t"
214 echo "Tests ${test_description}"
218 test_description_printed=
219 print_test_description () {
220 test -z "$test_description_printed" || return 0
222 echo $this_test: "Testing ${test_description}"
223 test_description_printed=1
225 if [ -z "$NOTMUCH_TEST_QUIET" ]
227 print_test_description
236 declare -a _exit_functions=()
238 at_exit_function () {
239 _exit_functions=($1 ${_exit_functions[@]/$1})
242 rm_exit_function () {
243 _exit_functions=(${_exit_functions[@]/$1})
250 for _fn in ${_exit_functions[@]}; do $_fn; done
251 rm -rf "$TEST_TMPDIR"
256 if test -n "$GIT_EXIT_OK"
261 say_color error '%-6s' FATAL
262 echo " $test_subtest_name"
264 echo "Unexpected exit while executing $0. Exit code $code."
271 echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
278 say_color error '%-6s' FATAL
281 echo "Unexpected exit while executing $0."
285 trap 'trap_exit' EXIT
286 trap 'trap_signal' HUP INT TERM
288 # Add an existing, fixed corpus of email to the database.
290 # $1 is the corpus dir under corpora to add, using "default" if unset.
292 # The default corpus is based on about 50 messages from early in the
293 # history of the notmuch mailing list, which allows for reliably
294 # testing commands that need to operate on a not-totally-trivial
295 # number of messages.
296 add_email_corpus () {
301 cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
302 notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
305 test_begin_subtest () {
306 if [ -n "$inside_subtest" ]; then
307 exec 1>&6 2>&7 # Restore stdout and stderr
308 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
310 test_subtest_name="$1"
312 # Redirect test output to the previously prepared file descriptors
313 # 3 and 4 (see below)
314 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
319 # Pass test if two arguments match
321 # Note: Unlike all other test_expect_* functions, this function does
322 # not accept a test name. Instead, the caller should call
323 # test_begin_subtest before calling this function in order to set the
325 test_expect_equal () {
326 local output expected testname
327 exec 1>&6 2>&7 # Restore stdout and stderr
328 if [ -z "$inside_subtest" ]; then
329 error "bug in the test script: test_expect_equal without test_begin_subtest"
333 error "bug in the test script: not 2 parameters to test_expect_equal"
337 if ! test_skip "$test_subtest_name"
339 if [ "$output" = "$expected" ]; then
342 testname=$this_test.$test_count
343 echo "$expected" > $testname.expected
344 echo "$output" > $testname.output
345 test_failure_ "$(diff -u $testname.expected $testname.output)"
351 local file1 file2 testname basename1 basename2
354 if ! test_skip "$test_subtest_name"
356 if diff -q "$file1" "$file2" >/dev/null ; then
359 testname=$this_test.$test_count
360 basename1=`basename "$file1"`
361 basename2=`basename "$file2"`
362 cp "$file1" "$testname.$basename1"
363 cp "$file2" "$testname.$basename2"
364 test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
369 # Like test_expect_equal, but takes two filenames.
370 test_expect_equal_file () {
371 exec 1>&6 2>&7 # Restore stdout and stderr
372 if [ -z "$inside_subtest" ]; then
373 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
377 error "bug in the test script: not 2 parameters to test_expect_equal_file"
379 test_diff_file_ "$1" "$2"
382 # Like test_expect_equal_file, but compare the part of the two files after the first blank line
383 test_expect_equal_message_body () {
384 exec 1>&6 2>&7 # Restore stdout and stderr
385 if [ -z "$inside_subtest" ]; then
386 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
389 error "bug in the test script: not 2 parameters to test_expect_equal_file"
391 expected=$(sed '1,/^$/d' "$1")
392 output=$(sed '1,/^$/d' "$2")
393 test_expect_equal "$expected" "$output"
396 # Like test_expect_equal, but takes two filenames. Fails if either is empty
397 test_expect_equal_file_nonempty () {
398 exec 1>&6 2>&7 # Restore stdout and stderr
399 if [ -z "$inside_subtest" ]; then
400 error "bug in the test script: test_expect_equal_file_nonempty without test_begin_subtest"
404 error "bug in the test script: not 2 parameters to test_expect_equal_file_nonempty"
406 for file in "$1" "$2"; do
407 if [ ! -s "$file" ]; then
408 test_failure_ "Missing or zero length file: $file"
413 test_diff_file_ "$1" "$2"
416 # Like test_expect_equal, but arguments are JSON expressions to be
417 # canonicalized before diff'ing. If an argument cannot be parsed, it
418 # is used unchanged so that there's something to diff against.
419 test_expect_equal_json () {
420 local script output expected
421 # The test suite forces LC_ALL=C, but this causes Python 3 to
422 # decode stdin as ASCII. We need to read JSON in UTF-8, so
423 # override Python's stdio encoding defaults.
424 script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
425 output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
427 expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
430 test_expect_equal "$output" "$expected" "$@"
433 # Ensure that the argument is valid JSON data.
435 PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
436 test_expect_equal "$?" 0
439 # Sort the top-level list of JSON data from stdin.
441 PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
442 "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
445 # test for json objects:
446 # read the source of test/json_check_nodes.py (or the output when
447 # invoking it without arguments) for an explanation of the syntax.
450 exec 1>&6 2>&7 # Restore stdout and stderr
451 if [ -z "$inside_subtest" ]; then
452 error "bug in the test script: test_json_eval without test_begin_subtest"
456 error "bug in the test script: test_json_nodes needs at least 1 parameter"
458 if ! test_skip "$test_subtest_name"
460 output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
465 test_failure_ "$output"
471 notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
474 NOTMUCH_DUMP_TAGS () {
475 # this relies on the default format being batch-tag, otherwise some tests will break
476 notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
479 notmuch_drop_mail_headers () {
482 msg = email.message_from_file(sys.stdin)
483 for hdr in sys.argv[1:]: del msg[hdr]
484 print(msg.as_string(False))
488 notmuch_debug_sanitize () {
492 notmuch_exception_sanitize () {
493 perl -pe 's,(A Xapian exception occurred at) .*?([^/]*[.]cc?):([0-9]*),\1 \2:XXX,'
496 notmuch_search_sanitize () {
497 notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
500 notmuch_search_files_sanitize () {
501 notmuch_dir_sanitize | sed 's/msg-[0-9][0-9][0-9]/msg-XXX/'
504 notmuch_dir_sanitize () {
505 sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
508 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
509 notmuch_show_sanitize () {
510 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
512 notmuch_show_sanitize_all () {
513 notmuch_debug_sanitize | \
515 -e 's| filename:.*| filename:XXXXX|' \
516 -e 's| id:[^ ]* | id:XXXXX |' | \
517 notmuch_date_sanitize
520 notmuch_json_show_sanitize () {
522 -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
523 -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
524 -e 's|"filename": "signature.asc",||g' \
525 -e 's|"duplicate": 1,||g' \
526 -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
527 -e 's|"timestamp": 97.......|"timestamp": 42|g' \
528 -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
531 notmuch_sexp_show_sanitize () {
533 -e 's|:id "[^"]*"|:id "XXXXX"|g' \
534 -e 's|:Date "Sat, 01 Jan 2000 [^"]*0000"|:Date "GENERATED_DATE"|g' \
535 -e 's|:filename "signature.asc"||g' \
536 -e 's|:duplicate 1 ||g' \
537 -e 's|:filename ("/[^"]*")|:filename ("YYYYY")|g' \
538 -e 's|:timestamp 9........|:timestamp 42|g' \
539 -e 's|:content-length [1-9][0-9]*|:content-length "NONZERO"|g'
542 notmuch_sexp_search_sanitize () {
543 sed -e 's|:thread "[^"]*"|:thread "XXX"|'
546 notmuch_emacs_error_sanitize () {
552 notmuch_debug_sanitize < "$file"
556 -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
559 notmuch_date_sanitize () {
561 -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
564 # remove redundant parts of notmuch-git internal paths
565 notmuch_git_sanitize () {
566 sed -e 's,tags/\([0-9a-f]\{2\}/\)\{2\},,' -e '/FORMAT/d'
568 notmuch_uuid_sanitize () {
569 sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
572 notmuch_built_with_sanitize () {
573 sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
576 notmuch_config_sanitize () {
577 notmuch_dir_sanitize | notmuch_built_with_sanitize
580 notmuch_show_part () {
581 awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
584 # End of notmuch helper functions
586 # Use test_set_prereq to tell that a particular prerequisite is available.
588 # The prerequisite can later be checked for by using test_have_prereq.
590 # The single parameter is the prerequisite tag (a simple word, in all
591 # capital letters by convention).
594 satisfied="$satisfied$1 "
598 test_have_prereq () {
607 declare -A test_missing_external_prereq_
608 declare -A test_subtest_missing_external_prereq_
610 # declare prerequisite for the given external binary
611 test_declare_external_prereq () {
614 test "$#" = 2 && name=$2 || name="$binary(1)"
616 if ! hash $binary 2>/dev/null; then
617 test_missing_external_prereq_["${binary}"]=t
620 test_subtest_missing_external_prereq_[\"${name}\"]=t
626 # You are not expected to call test_ok_ and test_failure_ directly, use
627 # the text_expect_* functions instead.
630 if test "$test_subtest_known_broken_" = "t"; then
631 test_known_broken_ok_
634 test_success=$(($test_success + 1))
635 if test -n "$NOTMUCH_TEST_QUIET"; then
638 say_color pass "%-6s" "PASS"
639 echo " $test_subtest_name"
643 print_test_description
644 if test "$test_subtest_known_broken_" = "t"; then
645 test_known_broken_failure_ "$@"
648 test_failure=$(($test_failure + 1))
649 test_failure_message_ "FAIL" "$test_subtest_name" "$@"
650 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
654 test_failure_message_ () {
655 say_color error "%-6s" "$1"
658 if [ "$#" != "0" ]; then
659 echo "$@" | sed -e 's/^/ /'
661 if test "$verbose" != "t"; then cat test.output; fi
664 test_known_broken_ok_ () {
666 test_fixed=$(($test_fixed+1))
667 say_color pass "%-6s" "FIXED"
668 echo " $test_subtest_name"
671 test_known_broken_failure_ () {
673 test_broken=$(($test_broken+1))
674 if [ -z "$NOTMUCH_TEST_QUIET" ]; then
675 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
677 test_failure_message_ "BROKEN" "$test_subtest_name"
683 test "$debug" = "" || eval "$1"
688 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
691 eval >&3 2>&4 "$test_cleanup"
696 test_count=$(($test_count+1))
698 for skp in $NOTMUCH_SKIP_TESTS
700 case $this_test.$test_count in
705 case $this_test_bare.$test_count in
713 test_report_skip_ "$@"
716 test_check_missing_external_prereqs_ "$@"
721 test_check_missing_external_prereqs_ () {
722 if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
723 say_color skip >&1 "missing prerequisites: "
724 echo ${!test_subtest_missing_external_prereq_[@]} >&1
725 test_report_skip_ "$@"
731 test_report_skip_ () {
733 say_color skip >&3 "skipping test:"
735 say_color skip "%-6s" "SKIP"
739 test_subtest_known_broken () {
740 test_subtest_known_broken_=t
743 test_expect_success () {
744 exec 1>&6 2>&7 # Restore stdout and stderr
745 if [ -z "$inside_subtest" ]; then
746 error "bug in the test script: test_expect_success without test_begin_subtest"
750 error "bug in the test script: not 1 parameters to test_expect_success"
752 if ! test_skip "$test_subtest_name"
756 # test_run_ may update missing external prerequisites
757 test_check_missing_external_prereqs_ "$test_subtest_name" ||
758 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
767 test_expect_code () {
768 exec 1>&6 2>&7 # Restore stdout and stderr
769 if [ -z "$inside_subtest" ]; then
770 error "bug in the test script: test_expect_code without test_begin_subtest"
774 error "bug in the test script: not 2 parameters to test_expect_code"
776 if ! test_skip "$test_subtest_name"
780 # test_run_ may update missing external prerequisites,
781 test_check_missing_external_prereqs_ "$test_subtest_name" ||
782 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
786 test_failure_ "exit code $eval_ret, expected $1" "$2"
791 # This is not among top-level (test_expect_success)
792 # but is a prefix that can be used in the test script, like:
794 # test_expect_success 'complain and die' '
796 # do something else &&
797 # test_must_fail git checkout ../outerspace
800 # Writing this as "! git checkout ../outerspace" is wrong, because
801 # the failure could be due to a segv. We want a controlled failure.
805 test $? -gt 0 -a $? -le 129 -o $? -gt 192
808 # test_cmp is a helper function to compare actual and expected output.
809 # You can use it like:
811 # test_expect_success 'foo works' '
812 # echo expected >expected &&
814 # test_cmp expected actual
817 # This could be written as either "cmp" or "diff -u", but:
818 # - cmp's output is not nearly as easy to read as diff -u
819 # - not all diff versions understand "-u"
825 # This function can be used to schedule some commands to be run
826 # unconditionally at the end of the test to restore sanity:
828 # test_expect_success 'test core.capslock' '
829 # git config core.capslock true &&
830 # test_when_finished "git config --unset core.capslock" &&
834 # That would be roughly equivalent to
836 # test_expect_success 'test core.capslock' '
837 # git config core.capslock true &&
839 # git config --unset core.capslock
842 # except that the greeting and config --unset must both succeed for
845 test_when_finished () {
847 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
852 test_results_dir="$TEST_DIRECTORY/test-results"
853 mkdir -p "$test_results_dir"
854 test_results_path="$test_results_dir/$this_test"
857 "success $test_success" \
858 "fixed $test_fixed" \
859 "broken $test_broken" \
860 "failed $test_failure" \
861 "total $test_count" \
864 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
866 if [ "$test_failure" = "0" ]; then
867 if [ "$test_broken" = "0" ]; then
877 # Note: if there is need to print debug information from python program,
878 # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
879 PYTHONPATH="$NOTMUCH_BUILDDIR/bindings/python-cffi/build/stage:$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
880 $NOTMUCH_PYTHON -B - > OUTPUT
884 local exec_file test_file
885 exec_file="test${test_count}"
886 test_file="${exec_file}.c"
888 ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
889 echo "== stdout ==" > OUTPUT.stdout
890 echo "== stderr ==" > OUTPUT.stderr
891 ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
892 notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
896 local exec_file test_file
897 exec_file="test${test_count}"
898 test_file="${exec_file}.c"
899 echo '#include <notmuch-private.h>' > ${test_file}
901 ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -I${NOTMUCH_SRCDIR}/util -I${NOTMUCH_SRCDIR}/compat ${NOTMUCH_GMIME_CFLAGS} -o ${exec_file} ${test_file} ${NOTMUCH_BUILDDIR}/lib/libnotmuch.a ${NOTMUCH_GMIME_LDFLAGS} ${NOTMUCH_XAPIAN_LDFLAGS} ${NOTMUCH_BUILDDIR}/util/libnotmuch_util.a ${NOTMUCH_SFSEXP_LDFLAGS} ${NOTMUCH_BUILDDIR}/parse-time-string/libparse-time-string.a -ltalloc -lstdc++
902 echo "== stdout ==" > OUTPUT.stdout
903 echo "== stderr ==" > OUTPUT.stderr
904 ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
905 notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
909 local base_name test_file shim_file
911 test_file="${base_name}.c"
912 shim_file="${base_name}.so"
914 ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
917 notmuch_with_shim () {
918 local base_name shim_file
921 shim_file="${base_name}.so"
922 LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
925 # Creates a script that counts how much time it is executed and calls
926 # notmuch. $notmuch_counter_command is set to the path to the
927 # generated script. Use notmuch_counter_value() function to get the
928 # current counter value.
929 notmuch_counter_reset () {
930 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
931 if [ ! -x "$notmuch_counter_command" ]; then
932 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
933 cat >"$notmuch_counter_command" <<EOF || return
936 read count < "$notmuch_counter_state_path"
937 echo \$((count + 1)) > "$notmuch_counter_state_path"
941 chmod +x "$notmuch_counter_command" || return
944 echo 0 > "$notmuch_counter_state_path"
947 # Returns the current notmuch counter value.
948 notmuch_counter_value () {
949 if [ -r "$notmuch_counter_state_path" ]; then
950 read count < "$notmuch_counter_state_path"
957 test_reset_state_ () {
958 test -z "$test_init_done_" && test_init_
960 test_subtest_known_broken_=
961 test_subtest_missing_external_prereq_=()
964 # called once before the first subtest
968 # skip all tests if there were external prerequisites missing during init
969 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
973 # Where to run the tests
974 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
976 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
978 # Use -P to resolve symlinks in our working directory so that the cwd
979 # in subprocesses like git equals our $PWD (for pathname comparisons).
980 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
982 if test "$verbose" = "t"
986 exec 4>test.output 3>&4
989 for skp in $NOTMUCH_SKIP_TESTS
992 for skp in $NOTMUCH_SKIP_TESTS
999 case "$this_test_bare" in
1007 say_color skip >&3 "skipping test $this_test altogether"
1008 say_color skip "skip all tests in $this_test"
1013 # Provide an implementation of the 'yes' utility
1028 # Fix some commands on Windows
1031 # Windows has its own (incompatible) sort and find
1041 # git sees Windows-style pwd
1045 # no POSIX permissions
1046 # backslashes in pathspec are converted to '/'
1047 # exec does not inherit the PID
1050 test_set_prereq POSIXPERM
1051 test_set_prereq BSLASHPSPEC
1052 test_set_prereq EXECKEEPSPID
1056 test -z "$NO_PERL" && test_set_prereq PERL
1057 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1059 # test whether the filesystem supports symbolic links
1060 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1063 # declare prerequisites for external binaries used in tests
1064 test_declare_external_prereq dtach
1065 test_declare_external_prereq emacs
1066 test_declare_external_prereq ${TEST_EMACSCLIENT}
1067 test_declare_external_prereq ${TEST_GDB}
1068 test_declare_external_prereq gpg
1069 test_declare_external_prereq openssl
1070 test_declare_external_prereq gpgsm
1071 test_declare_external_prereq ${NOTMUCH_PYTHON}
1072 test_declare_external_prereq xapian-metadata
1073 test_declare_external_prereq xapian-delve